Public Member Functions | Data Fields

# NetworkLobbyWindow Struct Reference

Inheritance diagram for NetworkLobbyWindow:

## Public Member Functions
| NetworkLobbyWindow (const WindowDesc *desc, NetworkGameList *ngl)
CompanyID | NetworkLobbyFindCompanyIndex (byte pos) const
virtual void | UpdateWidgetSize (int widget, Dimension *size, const Dimension &padding, Dimension *fill, Dimension *resize)
| Update size and resize step of a widget in the window.
virtual void | SetStringParameters (int widget) const
| Initialize string parameters for a widget.
virtual void | DrawWidget (const Rect &r, int widget) const
| Draw the contents of a nested widget.
virtual void | OnPaint ()
| The window must be repainted.
void | DrawMatrix (const Rect &r) const
void | DrawDetails (const Rect &r) const
virtual void | OnClick (Point pt, int widget, int click_count)
| A click with the left mouse button has been made on the window.
virtual void | OnResize ()
| Called after the window got resized.
## Data Fields
CompanyID | company
| Select company.
NetworkGameList * | server
| Selected server.
NetworkCompanyInfo | company_info [MAX_COMPANIES]
Scrollbar * | vscroll

## Detailed Description

Definition at line 1355 of file network_gui.cpp.

## Member Function Documentation

virtual void NetworkLobbyWindow::DrawWidget | ( | const Rect & | r,
|  | int | widget |
| ) |  |  | const`[inline, virtual]`

Draw the contents of a nested widget.

Parameters:

  | r | Rectangle occupied by the widget.
  | widget | Number of the widget to draw.

Note:
  This method may not change any state, it may only use drawing functions.

Reimplemented from Window.

Definition at line 1409 of file network_gui.cpp.

References WID_NL_DETAILS, and WID_NL_MATRIX.

virtual void NetworkLobbyWindow::OnClick | ( | Point | pt,
|  | int | widget,
|  | int | click_count |
| ) |  |  | `[inline, virtual]`

A click with the left mouse button has been made on the window.

Parameters:

  | pt | the point inside the window that has been clicked.
  | widget | the clicked widget.
  | click_count | Number of fast consecutive clicks at same position

Reimplemented from Window.

Definition at line 1544 of file network_gui.cpp.

References _settings_client, NetworkGameInfo::companies_on, COMPANY_NEW_COMPANY, COMPANY_SPECTATOR, Scrollbar::GetScrolledRowFromWidget(), NetworkGameList::info, INVALID_COMPANY, Window::IsWidgetDisabled(), NetworkSettings::last_host, NetworkSettings::last_port, ClientSettings::network, NetworkUDPQueryServer(), server, Window::SetDirty(), WID_NL_CANCEL, WID_NL_JOIN, WID_NL_MATRIX, WID_NL_NEW, WID_NL_REFRESH, and WID_NL_SPECTATE.

virtual void NetworkLobbyWindow::OnPaint | ( |  | ) | `[inline, virtual]`

The window must be repainted.

Note:
  This method should not change any state, it should only use drawing functions.

Reimplemented from Window.

Definition at line 1422 of file network_gui.cpp.

References NetworkGameInfo::companies_max, NetworkGameInfo::companies_on, company, Window::DrawWidgets(), GetLobbyCompanyInfo(), NetworkGameList::info, INVALID_COMPANY, server, Scrollbar::SetCount(), Window::SetWidgetDisabledState(), NetworkGameInfo::spectators_max, NetworkGameInfo::spectators_on, WID_NL_JOIN, WID_NL_NEW, and WID_NL_SPECTATE.

virtual void NetworkLobbyWindow::OnResize | ( |  | ) | `[inline, virtual]`

Called after the window got resized.

For nested windows with a viewport, call NWidgetViewport::UpdateViewportCoordinates.

Reimplemented from Window.

Definition at line 1583 of file network_gui.cpp.

References Scrollbar::GetCapacity(), MAT_COL_START, Scrollbar::SetCapacityFromWidget(), and WID_NL_MATRIX.

virtual void NetworkLobbyWindow::SetStringParameters | ( | int | widget | ) | const`[inline, virtual]`

Initialize string parameters for a widget.

Calls to this function are made during initialization to measure the size (that is as part of InitNested()), during drawing, and while re-initializing the window. Only for widgets that render text initializing is requested.

Parameters:

  | widget | Widget number.

Reimplemented from Window.

Definition at line 1400 of file network_gui.cpp.

References NetworkGameList::info, server, NetworkGameInfo::server_name, SetDParamStr(), and WID_NL_TEXT.

virtual void NetworkLobbyWindow::UpdateWidgetSize | ( | int | widget,
|  | Dimension * | size,
|  | const Dimension & | padding,
|  | Dimension * | fill,
|  | Dimension * | resize |
| ) |  |  | `[inline, virtual]`

Update size and resize step of a widget in the window.

After retrieval of the minimal size and the resize-steps of a widget, this function is called to allow further refinement, typically by computing the real maximal size of the content. Afterwards, size is taken to be the minimal size of the widget and resize is taken to contain the resize steps. For the convenience of the callee, padding contains the amount of padding between the content and the edge of the widget. This should be added to the returned size.

Parameters:

  | widget | Widget number.
  | size | Size of the widget.
  | padding | Recommended amount of space between the widget content and the widget edge.
  | fill | Fill step of the widget.
  | resize | Resize step of the widget.

Reimplemented from Window.

Definition at line 1382 of file network_gui.cpp.

References FONT_HEIGHT_NORMAL, WD_MATRIX_TOP, WID_NL_DETAILS, WID_NL_HEADER, and WID_NL_MATRIX.

The documentation for this struct was generated from the following file:

- src/network/network_gui.cpp